#!/usr/bin/perl
use strict;
use warnings;

my $USAGE = "Usage: $0 inputfile1 inputfile2\n";

my $inputfile1 = shift or die $USAGE;
my $inputfile2 = shift or die $USAGE;

my %seta;
my %setb;
my %setboth;

open(my $fh1, '<:encoding(UTF-8)', $inputfile1)
  or die "Could not open file '$inputfile1' $!";

while (my $row = <$fh1>) {
  chomp $row;
  $seta{$row} = $row;
}

close($fh1);

open(my $fh2, '<:encoding(UTF-8)', $inputfile2)
  or die "Could not open file '$inputfile2' $!";

while (my $row = <$fh2>) {
  chomp $row;
  $setb{$row} = $row;
}

close($fh2);

foreach my $row (keys %seta) {
		if (exists $setb{$row}) {
				$setboth{$row}=$row;
				delete $seta{$row};
				delete $setb{$row};
		}
}

open(my $fhout0, '>', 'output_in_1_only.list');
foreach my $row (keys %seta) {
		print $fhout0 $row . "\n";
}
close $fhout0;

open(my $fhout1, '>', 'output_in_2_only.list');
foreach my $row (keys %setb) {
		print $fhout1 $row . "\n";
}
close $fhout1;

open(my $fhout2, '>', 'output_in_both.list');
foreach my $row (keys %setboth) {
		print $fhout2 $row . "\n";
}
close $fhout2;
