#!/usr/bin/perl
use strict;
use warnings;

local $/ = "\r\n"; # Windows Linebreak: CRLF
my $USAGE = "Usage: $0 setfile updatefile\n";
my $KEY = 1; # ID column
my $LIMIT = $KEY + 1; # both files will only be delimited $LIMIT times.

my $largeset = shift or die $USAGE;
my $updateset = shift or die $USAGE;

open(my $fh, '<', $largeset)
  or die "Could not open file '$largeset' $!";
 
my %values;

while (my $row = <$fh>) {
  chomp $row;
  my @splitrow = split(/\|/, $row, $LIMIT); # we only need the first column as it's the ID
  my $key = $splitrow[$KEY-1]; # count begins at 0, not 1
  print STDERR "[DEBUG] Key=$key\n";
  $values{$key} = $row;
}

open(my $updatefile, '<', $updateset)
  or die "Could not open file '$updateset' $!";

while(my $row = <$updatefile>) {
  chomp $row;
  my @splitrow = split(/\|/, $row, $LIMIT);
  my $key = $splitrow[$KEY-1];
  # here the magic happens: We set the recognized value to the old value and simply append the new column(s).
  if (exists $values{$key}) {
    $values{$key} = $values{$key} . $splitrow[$KEY];
  } else {
    print STDERR "[INFO] Key $key not in $largeset. creating new entry with only the data from $updateset.\n";
    $values{$key} = $row;
  }
}

for my $id (keys %values) {
  print "$values{$id}\n";
}
