#!/usr/bin/perl
use strict;
use warnings;

# This script merges two datasets, when they are identical excluding one column

my $USAGE = "Usage: $0 setfile updatefile\n";
my $KEY = 1; # ID column
my $NEWCOL = 16; # the column that needs to be added to largeset from updateset

my $largeset = shift or die $USAGE;
my $updateset = shift or die $USAGE;

open(my $fh, '<:encoding(UTF-8)', $largeset)
  or die "Could not open file '$largeset' $!";

my %values;

while (my $row = <$fh>) {
  chomp $row;
  my @splitrow = split(/\|/, $row);
  $values{$splitrow[$KEY-1]} = $row; # count of arrays begins at 0, not 1
}

open(my $updatefile, '< :encoding(UTF-8)', $updateset)
  or die "Could not open file '$updateset' $!";

while(my $row = <$updatefile>) {
  chomp $row;
  my @splitrow = split(/\|/, $row); # split 2nd file
  $values{$splitrow[$KEY-1]} = $values{$splitrow[$KEY-1]} . "|" . $splitrow[$NEWCOL-1];
}

for my $id (keys %values) {
  print "$values{$id}\n";
}
